<?php

namespace Teknisa\CADFIN\Factories;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Financeiro\Entities\Classfinanc;
use Teknisa\Model\Financeiro\Entities\Dregerestru;

/**
 * Class Ger40100CategoriasDreGerencialFactory
 * @package Teknisa\CADFIN\Factories
 */
class Ger40100CategoriasDreGerencialFactory {

    protected $entityManager;

    /**
     * @param EntityManager $entityManager
     */
    public function __construct(EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
        $this->connection    = $entityManager->getConnection();
    }

    /**
     * Busca Categoria DRE
     * @param $nrorg
     * @param $cditemestru
     * @return Dregerestru
     */
    public function buscaDregerestru($nrorg, $cditemestru)
    {
        /** @var $params */
        $params = array();
        $params['nrorg']       = $nrorg;
        $params['cditemestru'] = $cditemestru;
        
        /** @var Dregerestru $dregerestru */
        $dregerestru = $this->entityManager->getRepository(Dregerestru::class)->findOneBy($params);

        return $dregerestru;
    }

    /**
     * Busca Classificações Financeiras - Categoria DRE
     * @param $nrorg
     * @param $cditemestru
     * @return Classfinanc
     */
    public function buscaClassfinancs($nrorg, $cditemestru)
    {
        /** @var $params */
        $params = array();
        $params['nrorg']       = $nrorg;
        $params['cditemestru'] = $cditemestru;
        
        /** @var Classfinanc $classfinanc */
        $classfinanc = $this->entityManager->getRepository(Classfinanc::class)->findBy($params);

        return $classfinanc;
    }

    /**
     * Busca Classificação Financeira
     * @param $nrorg
     * @param $cdclassfinanc
     * @return Classfinanc
     */
    public function buscaClassfinanc($nrorg, $cdclassfina)
    {
        /** @var $params */
        $params = array();
        $params['nrorg']       = $nrorg;
        $params['cdclassfina'] = $cdclassfina;
        
        /** @var Classfinanc $classfinanc */
        $classfinanc = $this->entityManager->getRepository(Classfinanc::class)->findOneBy($params);

        return $classfinanc;
    }
    
    /**
     * Atualiza Classificação Financeira - Categoria DRE
     * @param Classfinanc $classfinanc
     * @param $cditemestru  
     * @return mixed
     */
    public function atualizaClassFinancCategoriaDRE(
        Classfinanc $classfinanc, $cditemestru
    ){
        $classfinanc->setCditemestru($cditemestru);

        return $classfinanc;
    }
    
}